/* $Header: /usr2/brugere/jbln/uc133/src/RCS/mvcp.c,v 1.3 1995/03/06 23:18:47 jbln Exp jbln $ */

#include <stdio.h>
#include <malloc.h>
#include <string.h>
#include <ctype.h>
#include <dirent.h>

#include "uc.h"
#include "input.h"


#define BUFFERSIZE 512

/************************************************************
   DELETE / COPY / MOVE
************************************************************/

do_delete(pos)
int pos;
{
   int c;

   chdir(uc[pos].path);
   shortpath(pos);

   if (uc[pos].grpcou>0)
      do_groupdel(pos);
   else
   if (strcmp(GETINFO(pos).name, "..")==0)
      return(0);
   else
   {
      move(22,0);
      clrtoeol();
      printw("Delete %s %s (y/n) ? ", 
	     ftype_names[GETINFO(pos).type],
	     uc[pos].files[uc[pos].pos+uc[pos].offset].name);
      refresh();
      c = ti_getch();
      if (c=='y'  ||  c=='Y')
      {
	 if (GETINFO(pos).type==FTYPE_DIR)
	 {
	    if (uc[pos].showmode == SHOWTREE)
	       do_removedir(pos, uc[pos].path);
	    else
	       do_removedir(pos, GETINFO(pos).name);
         }
         else
         if (unlink(uc[pos].files[uc[pos].pos+uc[pos].offset].name)!=0)
	    print_error();

         if (uc[pos].showmode == SHOWTREE)
         {
            mkt_update();
            return(0);
         }
      }
   }

   update_screen(pos);
   if (strcmp(uc[pos].path, uc[N(pos)].path)==0)
      update_screen(N(pos));
   if (uc[pos].pos+uc[pos].offset >= uc[pos].filenum)
   {
      uc[pos].offset = uc[pos].filenum - uc[pos].size - 1;
      if (uc[pos].offset < 0)
	 uc[pos].offset = 0;
      uc[pos].pos = uc[pos].filenum - uc[pos].offset - 1;
      uc[pos].oldpos = -1;
      uc[pos].oldoffset = uc[pos].offset;
   }
   cursor(pos);

   return(1);
}


do_groupdel(pos)
int pos;
{
   char tmp[100];
   int c;
   int n;
   sprintf(tmp, "Delete %d files from %s (y/n) ? ", uc[pos].grpcou,
					            uc[pos].path);
   prompt(tmp, ">");
   c = ti_getch();
   if (c=='y'  ||  c=='Y')
   {
      prompt("Deleting...","");
      for (n=0 ; n<uc[pos].filenum ; n++)
      {
	 if (uc[pos].files[n].mark && uc[pos].files[n].type==FTYPE_NORM)
            if (unlink(uc[pos].files[n].name)!=0)
	    {
               move(22,0);
               clrtoeol();
               if (errno >= sys_nerr)
                  printw("Unknown error : code %d for file %s", errno,
			 uc[pos].files[n].name);
               else
                  printw("%s : %s.", uc[pos].files[n].name,
			 sys_errlist[errno]);
               refresh();
               ti_getch();
            }
      }
   }
}


do_removedir(pos, dirname)
int pos;
char *dirname;
{
   int c, clrall=0;

   if (rmdir(dirname) != 0)
   {
      prompt("Also remove subdirectories (y/n/all) ? ",">");
      c = ti_getch();
      prompt("Please wait ...", "");
      if (c=='y' || c=='Y' || c=='a' || c=='A')
      {
	 if (c=='a' || c=='A')
	    clrall=1;
         if (chdir(dirname) == 0)
            do_rec_rmdir(clrall);
         else
	    print_error();
      }
      chdir(uc[pos].path);
      shortpath(pos);
      rmdir(dirname);
   }
   return(1);
}


do_rec_rmdir(clrall)
int clrall;
{
   DIR *dirp;
   char tmp[200];
   struct dirent *dp;
   struct stat fstat;
   FILEINFO *files;
   int filenum=0;
   int type;
   int c,n,first=1;

   getcwd(tmp, 198);

   for (n=0 ; n<2 ; n++)
   {
      dirp = opendir(".");
      while ( (dp=readdir(dirp)) != (struct dirent *)NULL )
      {
         stat(dp->d_name, &fstat);
         if (strcmp(dp->d_name, ".")!=0  && strcmp(dp->d_name, "..")!=0)
         {
            if (n==1  &&  (fstat.st_mode & FMODE_SPEC)==FMODE_DIR)
            {
               if (chdir(dp->d_name)==0)
                  clrall = do_rec_rmdir(clrall);
	       chdir(tmp);

               if (!clrall)
               {
                  move(22,0);
                  clrtoeol();
                  printw("Remove directoy %s/%s (y/n/all) ? > ", tmp, dp->d_name);
                  refresh();
                  c = ti_getch();
                  move(22,0);
                  clrtoeol();
                  refresh();
                  if (c=='a' || c=='A')
	             clrall = 1;
                  else
                  if (c!='y'  &&  c!='Y')
	             return(clrall);
                  rmdir(dp->d_name);
               }
               else
                  rmdir(dp->d_name);
            }
            else
            {
	       unlink(dp->d_name);
            }
         }
      }
      closedir(dirp);
   }
   return(clrall);
}


do_copy(pos)
int pos;
{
   char path[UCNAMESIZE+1];
   int len;
   RETONTREE(pos);

   if (uc[pos].grpcou>0)
      do_groupcopy(pos);
   else
   if (GETINFO(pos).type == FTYPE_NORM)
   {
      len = strlen(GETINFO(pos).name);
      move(22,0);
      clrtoeol();
      printw("Copy file %s to : ", GETINFO(pos).name);
      refresh();
      strcpy(path, uc[N(pos)].path);
      if (inp_input(16+len, 22, path, 64-len, UCNAMESIZE,INPKEEP)==INPENTER)
      {
	 prompt("Please wait ...","");
	 copyfile(uc[pos].path, GETINFO(pos).name, path, 1);
	 update_bscreens();
	 cursor(pos);
      }
   }

   return(1);
}


do_groupcopy(pos)
int pos;
{
   char path[UCNAMESIZE+1];
   int c;
   int n;
   int found=0;

   move(22,0);
   clrtoeol();
   printw("Copy %3d files to : ", uc[pos].grpcou,uc[N(pos)].path);
   refresh();

   strcpy(path, uc[N(pos)].path);
   if (inp_input(20,22, path, 60, UCNAMESIZE,INPKEEP)==INPENTER)
   {
      prompt("Copying ...","");
      for (n=0 ; n<uc[pos].filenum ; n++)
      {
	 if (uc[pos].files[n].mark && uc[pos].files[n].type==FTYPE_NORM)
            if (copyfile(uc[pos].path,uc[pos].files[n].name,path,1)==1)
            {
               uc[pos].files[n].mark = 0;
	       found=1;
            }
      }
      if (found)
      {
	 update_bscreens();
	 cursor(pos);
      }
   }
}


do_move(pos)
int pos;
{
   char path[UCNAMESIZE+1];
   char fname[UCNAMESIZE+1];
   int len;
   struct stat st;
   RETONTREE(pos);

   if (uc[pos].grpcou>0)
      do_groupmove(pos);
   else
   if (GETINFO(pos).type == FTYPE_NORM)
   {
      len = strlen(GETINFO(pos).name);
      move(22,0);
      clrtoeol();
      strcpy(path, uc[N(pos)].path);
      sprintf(fname, "%s/%s", uc[pos].path, GETINFO(pos).name);
      printw("Move file %s to : ", GETINFO(pos).name);
      refresh();
      if (inp_input(16+len, 22, path, 64-len ,UCNAMESIZE,INPKEEP)==INPENTER)
      {
         if (stat(path,&st)==0)
         {
            move(22,0);
            clrtoeol();
            printw("File %s exists.  Overwrite ? ", GETINFO(pos).name);
            refresh();
            if (getuch() != 'Y')
	       return(0);
	 }
	 prompt("Please wait ...","");
	 if (rename(fname, path) != 0)
	    if (copyfile(uc[pos].path, GETINFO(pos).name, path,0)==1)
               deletefile(uc[pos].path, GETINFO(pos).name);
	 update_bscreens();
	 cursor(pos);
      }
   }

   return(1);
}


do_groupmove(pos)
int pos;
{
   char path[UCNAMESIZE+1];
   int c;
   int n;
   struct stat st;

   move(22,0);
   clrtoeol();
   printw("Move %3d files to : ", uc[pos].grpcou,uc[N(pos)].path);
   refresh();

   strcpy(path, uc[N(pos)].path);

   if (inp_input(20, 22, path, 60, UCNAMESIZE,INPKEEP)==INPENTER)
   {
      prompt("Moving ...","");
      for (n=0 ; n<uc[pos].filenum ; n++)
      {
	 if (uc[pos].files[n].mark && uc[pos].files[n].type==FTYPE_NORM)
	 {
            if (copyfile(uc[pos].path,uc[pos].files[n].name,path,1)==1)
            {
               deletefile(uc[pos].path, uc[pos].files[n].name);
            }
	 }
      }
      update_bscreens();
      cursor(pos);
   }
}


copyfile(p1,n1,dst,doprompt)
char *p1,*n1,*dst;
int doprompt;
{
   char iname[UCPATHSIZE], tmp[UCNAMESIZE];
   char odir[UCPATHSIZE], oname[UCNAMESIZE];
   char buffer[BUFFERSIZE];
   struct stat st;
   int cou, ok=1;
   FILE *ifile, *ofile;

   while (p1[strlen(p1)-1]=='/')
      p1[strlen(p1)-1]=0;
   if (strlen(n1)>0)
      sprintf(iname, "%s/%s", p1, n1);
   else
      sprintf(iname, "%s", p1);

   fname_split(dst, odir, oname);
   fname_subst(n1, oname, tmp);
   sprintf(oname, "%s%s", odir, tmp);
   if (stat(oname,&st)==0)
   {
      if ( (st.st_mode & FMODE_SPEC) == FMODE_DIR)
      {
         strcat(oname, "/");
         strcat(oname, n1);
      }
   }

   if (strcmp(iname,oname)==0)
   {
      prompt("Can't copy file to itself","");
      ti_getch();
      return(0);
   }

   if (stat(oname,&st)==0  &&  doprompt)
   {
      move(22,0);
      clrtoeol();
      printw("File %s exists.  Overwrite ? ", oname);
      refresh();
      if (getuch()!='Y')
         return(0);
   }

   if ( (ifile=fopen(iname, "rb")) == (FILE *)NULL )
   {
      prompt("Can't open file : ", iname);
      ti_getch();
      return(0);
   }

   if ( (ofile=fopen(oname, "wb")) == (FILE *)NULL )
   {
      prompt("Can't open file : ", oname);
      ti_getch();
      return(0);
   }

   while ( (cou=fread(buffer,1,BUFFERSIZE,ifile)) > 0)
   {
      fwrite(buffer,1,cou,ofile);
   }

   if (fclose(ifile)!=0)
      ok=0;
   if (fclose(ofile)!=0)
      ok=0;

   if (stat(iname,&st)==0)
      if ( chmod(oname, st.st_mode) != 0 )
      {
         print_error();
         ok=0;
      }

   return(ok);
}


deletefile(path,name)
char *path,*name;
{
   char fname[200];
   if (strlen(name)>0)
      sprintf(fname,"%s/%s", path,name);
   else
      sprintf(fname,"%s", path);
   if (unlink(fname)!=0)
      print_error();
}
